Attribute VB_Name = "IDAutomation_Native_DataBar_VBA_DEMO"
'*********************************************************************
' IDAutomation Native Barcode Generator 2017 DEMO
'  Copyright 2017, IDAutomation.com, Inc. All rights reserved.
' Portions of this program utilize IDAutomation USA Patent 7,637,436
'
' DEMO VERSION NOTICE:
' The demo version of this product contains a static barcode that may be
' used for evaluation purposes only to prove functionality.
' The static barcode cannot be changed because this would reveal the
' complete VBA formula, which is only available in the purchased version.
' For testing and evaluation purposes, only the following properties may be changed:
' TextControlName, ReportControlName, MILS, DPI & Orientation.
'
' The fully functional purchased version is provided with a 30 day
' money back satisfaction guarantee. If it is necessary to test dynamic
' barcodes with this product, the purchased version is required.
'
' Purchase Link:
' http://www.idautomation.com/barcode-components/access-native/#licensing
'
' User Manual and Tutorial:
' http://www.idautomation.com/barcode-components/access-native/user-manual.html
'
' For testing and evaluation purposes, only the following properties may be changed:
' TextControlName, ReportControlName, MILS, DPI & Orientation.
'
'*********************************************************************



Option Explicit

Private mvarMatrix() As Integer
Dim cols As Integer
Dim rows As Integer
  
'' Databar Expanded Stacked with segments
Public Function IDAutomation_NativeGS1DataBarExpanded(TextControlName As Control, _
                                                    ReportControlName As Object, _
                                                    Optional ExpandedStackedSegments As Integer = 6, _
                                                    Optional Height As Integer = 24, _
                                                    Optional Mils As Long = 12, _
                                                    Optional DPI As Long = 300, _
                                                    Optional Orientation As Long = 0, _
                                                    Optional QuiteZone As Integer = 1, _
                                                    Optional ToForm As Boolean = False) As String

    Dim PrintableString As String
      
    PrintableString = "awawwwwwaaawawaaawwawwwwwwwwaaaawawaaaaawwaaaaawawawwaawawwaaaaawaaawawwwwwaaaaaawwawwawwaaawwwaaaawaaawwwawwwawwwwawaaawwwwwwaaaawawawwaawwwwaaaawwawa" & vbCrLf
    PrintableString = PrintableString & "wawaywywztzwvszxvsuxuwywywywztvxyxutvxvxywzxvxvszwzsyxzwvsytzxzxytvxutuwysutvtvtvwuxuszwutvxywuxzxvszxzwuwzsysvwywutuxvxywywywzxvtyxutywvxususvxztuswaw"
    
    
    '' Create a matrix of 0 and 1 to render as image
    Call fromString2Matrix(PrintableString, Height, QuiteZone, mvarMatrix, rows, cols)
    
    If ToForm Then
      'Draw the symbol on a Form
      ReportControlName = zzMatrix2MonoFont()
    Else
      'Draw the symbol on a Report
      Call zzMatrix2AccessImage(TextControlName, ReportControlName, Mils, DPI, Orientation)
    End If
    
End Function

'' Convert pritable string to 0 and 1 matrix
Private Sub fromString2Matrix(PrintableString As String, mHeight As Integer, mQuietZone As Integer, ByRef resultBitmap() As Integer, ByRef rows As Integer, ByRef cols As Integer)

    Dim xSize As Integer
    Dim ySize As Integer
    Dim c As String
    Dim xPos As Integer
    Dim yPos As Integer
    Dim RowsToPrint() As String
    Dim nRow As Integer
    Dim nRows As Integer
    Dim finalWidth As Integer
    Dim finalHeight As Integer
    Dim i As Integer
    Dim X As Integer
    Dim Y As Integer
    
    RowsToPrint = Split(PrintableString, vbCrLf) '' chr(13) & chr(10))
    
    '' find width of bitmap
    xSize = 0
    ySize = 3 + mHeight
    nRows = UBound(RowsToPrint) + 1
    
    For i = 1 To Len(RowsToPrint(0))
      c = Mid(RowsToPrint(0), i, 1)
      If (c >= "1" And c <= "9") Then
        xSize = xSize + CInt(Val(c))
      ElseIf (c >= "p" And c <= "z") Then
        xSize = xSize + 1
      ElseIf (c >= "a" And c <= "i") Then
        xSize = xSize + Asc(c) - 97 + 1
      End If
    Next
  
    '' calc final size width and height
    finalWidth = xSize + 2 * mQuietZone
    finalHeight = ySize * nRows + 2 * mQuietZone - 3 '' remove first 3 lines on first rows, always blank
    
    rows = finalHeight
    cols = finalWidth
    
    '' to resize matrix ()
    ReDim resultBitmap(finalHeight - 1, finalWidth - 1)

    '' convert string to pixel bars
    yPos = mQuietZone - 3
    For nRow = 0 To nRows - 1
      xPos = mQuietZone
      For i = 1 To Len(RowsToPrint(nRow))
        c = Mid(RowsToPrint(nRow), i, 1)
        If (c >= "a" And c <= "i") Then
          xPos = xPos + Asc(c) - 97 + 1
        ElseIf (c >= "1" And c <= "9") Then
          For X = 1 To CInt(Val(c))
            For Y = 1 To mHeight
              resultBitmap(2 + Y + yPos, xPos) = 1
            Next
            xPos = xPos + 1
          Next
        ElseIf (c >= "w" And c <= "z") Then
          For Y = 1 To mHeight
            resultBitmap(2 + Y + yPos, xPos) = 1
          Next
          If (c = "x") Then
            resultBitmap(0 + yPos, xPos) = 1
          ElseIf (c = "y") Then
            resultBitmap(1 + yPos, xPos) = 1
          ElseIf (c = "z") Then
            resultBitmap(0 + yPos, xPos) = 1
            resultBitmap(1 + yPos, xPos) = 1
          End If
          xPos = xPos + 1
        ElseIf (c >= "p" And c <= "v") Then
          If (c = "p") Then
            resultBitmap(0 + yPos, xPos) = 1
          ElseIf (c = "q") Then
            resultBitmap(1 + yPos, xPos) = 1
          ElseIf (c = "r") Then
            resultBitmap(0 + yPos, xPos) = 1
            resultBitmap(1 + yPos, xPos) = 1
          ElseIf (c = "s") Then
            resultBitmap(2 + yPos, xPos) = 1
          ElseIf (c = "t") Then
            resultBitmap(0 + yPos, xPos) = 1
            resultBitmap(2 + yPos, xPos) = 1
          ElseIf (c = "u") Then
            resultBitmap(1 + yPos, xPos) = 1
            resultBitmap(2 + yPos, xPos) = 1
          ElseIf (c = "v") Then
            resultBitmap(0 + yPos, xPos) = 1
            resultBitmap(1 + yPos, xPos) = 1
            resultBitmap(2 + yPos, xPos) = 1
          End If
          xPos = xPos + 1
        End If
      Next
      yPos = yPos + ySize
    Next

End Sub


Private Function zzMatrix2AccessImage(TextControlName As Control, _
                                      ReportControlName As Object, _
                                      Mils As Long, _
                                      DPI As Long, _
                                      Orientation) As String
                                 
    Dim CurrentValue As Long
    Dim WeightValue As Long
    Dim currentX As Integer
    Dim currentY As Integer
    Dim Factor As Long
    Dim XPixles As Long
    Dim CanvasCurrentX As Long
    Dim CanvasCurrentY As Long
    Dim CanvasTop As Long
    Dim CanvasHeight As Long
    Dim CanvasWidth As Long

    Dim j As Integer
    Dim i As Integer
    '************************************************
    'Begin code to draw the symbol
    'Ensure accurate symbols at low resolutions:
    If DPI < 301 And Mils < 8 Then Mils = 8
    If DPI < 204 And Mils < 12 Then Mils = 12
    'Ensure accurate DPI
    If DPI < 72 Or DPI > 3000 Then DPI = 600
    'Convert Mils to Twips in CurrentValue:
    CurrentValue = Mils * 1.44
    'The following formulas match the value in twips with the resolution of
    'the printer as best as possible to create the highest quality symbol:
    WeightValue = CInt(1000 * (1000 / DPI))
    Factor = (Mils * 1.44 * 1000) Mod WeightValue
    If Factor <> 0 Then
       XPixles = CInt(Mils * 1.44 + ((WeightValue - Factor) / 1000))
    Else
       XPixles = CInt(Mils * 1.44)
    End If
    'Determine the location and size of the TextControl:
    CanvasCurrentX = TextControlName.Left
    CanvasTop = TextControlName.top
    CanvasHeight = TextControlName.Height
    CanvasCurrentY = CanvasTop
    CanvasWidth = TextControlName.Width
    If Orientation = 270 Then
        'CanvasCurrentX = TextControlName.Left
        CanvasCurrentY = CanvasTop + CanvasHeight
    ElseIf Orientation = 90 Then
        CanvasCurrentX = TextControlName.Left + CanvasWidth
    End If
    'The Visible property must be set to false to keep the text from appearing in the TextControl:
    TextControlName.Visible = False
    'The symbol is painted 1 row at a time from left to right
    Dim j1 As Integer
    Dim i1 As Integer
    For j1 = 0 To rows - 1
         If Orientation = 0 Then
            CanvasCurrentX = TextControlName.Left
            For i1 = 0 To cols - 1
               If mvarMatrix(j1, i1) = 0 Then 'it is a "WHITE" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 16777215, BF
               Else                       'it is a "BLACK" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 0, BF
               End If                     'Next Column
               CanvasCurrentX = CanvasCurrentX + XPixles
            Next i1 'Next Row
            CanvasCurrentY = CanvasCurrentY + XPixles
        ElseIf Orientation = 90 Then
            For i1 = 0 To cols - 1
               If mvarMatrix(j1, i1) = 0 Then 'it is a "WHITE" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(-XPixles, XPixles), 16777215, BF
               Else                       'it is a "BLACK" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(-XPixles, XPixles), 0, BF
               End If                     'Next Column
               CanvasCurrentY = CanvasCurrentY + XPixles
            Next i1 'Next Row
            CanvasCurrentY = CanvasTop
            CanvasCurrentX = CanvasCurrentX - XPixles
        ElseIf Orientation = 270 Then
            CanvasCurrentY = CanvasTop + CanvasHeight
            For i1 = 0 To cols - 1
               If mvarMatrix(j1, i1) = 0 Then 'it is a "WHITE" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 16777215, BF
               Else                       'it is a "BLACK" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 0, BF
               End If                     'Next Column
               CanvasCurrentY = CanvasCurrentY - XPixles
            Next i1 'Next Row
            CanvasCurrentX = CanvasCurrentX + XPixles
        Else
            CanvasCurrentX = TextControlName.Left
            For i1 = 0 To cols - 1
               If mvarMatrix(j1, i1) = 0 Then 'it is a "WHITE" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 16777215, BF
               Else                       'it is a "BLACK" square
                 ReportControlName.Line (CanvasCurrentX, CanvasCurrentY)-Step(XPixles, -XPixles), 0, BF
               End If                     'Next Column
               CanvasCurrentX = CanvasCurrentX + XPixles
            Next i1 'Next Row
            CanvasCurrentY = CanvasCurrentY + XPixles
        End If
    Next j1
End Function

Private Function zzMatrix2MonoFont() As String
    Dim j As Integer
    Dim i As Integer
    Dim Size As Integer
    Dim ww As String
    Dim wb As String
    Dim bw As String
    Dim bb As String
    Dim fontText As String
    
    '  ** BEGIN FONT FORMATTING CODE **
    '  The font is painted 4 rows at a time from left to right
    ww = ChrW(32) 'Top to bottom
    wb = ChrW(9604)
    bw = ChrW(9600)
    bb = ChrW(9608)
    Dim j1 As Integer
    For j1 = 0 To rows - 1 Step 2
       Dim i1 As Integer
       For i1 = 0 To cols - 1
          ' ** if = 0 then it is a "w" square **
          'Row 1
          If mvarMatrix(j1, i1) = 0 Then
             'Row 2
             If (j1 + 1 < rows) Then
                If mvarMatrix((j1 + 1), i1) = 0 Then
                  fontText = fontText & ww
                Else
                  fontText = fontText & wb
                End If
             Else
               fontText = fontText & ww
             End If
          Else
            If (j1 + 1 < rows) Then
               If mvarMatrix((j1 + 1), i1) = 0 Then
                 fontText = fontText & bw
               Else
                 fontText = fontText & bb
               End If
            Else
               fontText = fontText & bw
            End If
          End If
       Next i1 'Insert a return
       fontText = fontText + ChrW(13) + ChrW(10)
    Next j1
    zzMatrix2MonoFont = fontText
End Function

